// Original source code from
// http://www.learningprocessing.com
// Example 16-11: Simple color tracking
// Code has been modify for class IAT 884 summer 2014

import processing.video.*;

// Variable for capture device
Capture video;

// A variable for the color we are searching for.
color trackColor; 
int average_x = 0;
int average_y=0;
float r3 = 0;
float g3 = 0;
float b3= 0;

//Initial Setup
void setup() {
  size(640,480);  // Size of canvas, this size needs to match resolution of what your webcam capture. 
  String[] cameras = Capture.list();  // store available camera in string variable. 
  video = new Capture(this,cameras[4]);  // video object 
  video.start();  // initial video
  // Start off tracking for red
  trackColor = color(255,0,0); 
  smooth();
  
  
// Print avaiable camera on your PC and display resolution
   println("Available cameras:");
    for (int i = 0; i < cameras.length; i++) {
      println(cameras[i]);
    }
  
}

void draw() {
  // Capture and display the video
  if (video.available()) {
    video.read();
  }
video.loadPixels();
  image(video,0,0);

  // Before we begin searching, the "world record" for closest color is set to a high number that is easy for the first pixel to beat.
  float worldRecord = 500; 

  // XY coordinate of closest color
  int closestX = 0;
  int closestY = 0;

  // Begin loop to walk through every pixel
  for (int x = 0; x < video.width; x ++ ) {
    for (int y = 0; y < video.height; y ++ ) {
      int loc = x + y*video.width;
      // What is current color
      color currentColor = video.pixels[loc];
      float r1 = red(currentColor);
      float g1 = green(currentColor);
      float b1 = blue(currentColor);
      float r2 = red(trackColor);
      float g2 = green(trackColor);
      float b2 = blue(trackColor);
      
 

      // Using euclidean distance to compare colors
      float d = dist(r1,g1,b1,r2,g2,b2); // We are using the dist( ) function to compare the current color with the color we are tracking.

      // If current color is more similar to tracked color than
      // closest color, save current location and current difference
      if (d < worldRecord) {
        worldRecord = d;
        closestX = x;    
        closestY = y;
       average_x=(average_x+closestX)/2;   //average x value
       average_y=(average_y+closestY)/2;   // average y value 

      }
    }
  }

  // We only consider the color found if its color distance is less than 10. 
  // This threshold of 10 is arbitrary and you can adjust this number depending on how accurate you require the tracking to be.
  if (worldRecord < 10) { 
    // Draw a circle at the tracked pixel
    fill(trackColor);
    strokeWeight(4.0);
    stroke(0);
    ellipse(closestX,closestY,16,16);
    //ellipse(average_x,average_y,16,16);
    println("x: "+closestX+" y:"+closestY);   // print X Y location 

  }
}

void mousePressed() {
  // Save color where the mouse is clicked in trackColor variable
  int loc = mouseX + mouseY*video.width;
  trackColor = video.pixels[loc];
    r3 = red(trackColor);
       g3 = green(trackColor);
       b3 = blue(trackColor);
  
}
 void quit(){
      println("Color = r:"+r3+" g:"+g3+" b:"+b3);
 }
   
